var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import React from 'react';
import moment from 'moment';
import styled from 'styled-components';
var predefinedDates = [
    {
        text: 'Last 24 hours',
        start: moment().subtract(1, 'day'),
        end: moment(),
    },
    {
        text: 'Yesterday',
        start: moment().subtract(1, 'day').startOf('day'),
        end: moment().subtract(1, 'day').endOf('day'),
    },
    {
        text: 'Last week',
        start: moment().subtract(1, 'week'),
        end: moment(),
    },
    {
        text: 'Last month',
        start: moment().subtract(1, 'month'),
        end: moment(),
    },
    {
        text: 'Last year',
        start: moment().subtract(1, 'year'),
        end: moment(),
    },
];
var isSameDateRange = function (dateRange, predefinedDateRange) {
    var initialStart = dateRange.startDate, initialEnd = dateRange.endDate;
    var startDate = predefinedDateRange.startDate, endDate = predefinedDateRange.endDate;
    if (initialStart && initialEnd) {
        return (moment(initialStart).isSame(startDate, 'minutes') &&
            moment(initialEnd).isSame(endDate, 'minutes'));
    }
    return false;
};
export var PredefinedDates = function (_a) {
    var startDate = _a.startDate, endDate = _a.endDate, onChange = _a.onChange;
    var handleClick = function (item) { return function () {
        var start = item.start, end = item.end;
        onChange({ startDate: start.toDate(), endDate: end.toDate() });
    }; };
    return (React.createElement(PredefinedDatesWrapper, null,
        React.createElement(PredefinedDatesHeader, null, "Predefined periods"),
        React.createElement(PredefinedDatesList, null, predefinedDates.map(function (item) {
            var isSelected = isSameDateRange({ startDate: startDate, endDate: endDate }, {
                startDate: item.start,
                endDate: item.end,
            });
            return (React.createElement("li", { key: item.text },
                React.createElement(PredefinedDatesButton, { onClick: handleClick(item), isSelected: isSelected }, item.text)));
        }))));
};
export var PredefinedDatesHeader = styled('header').withConfig({ displayName: "PredefinedDatesHeader", componentId: "sc-aksdx" })(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  margin-bottom: 5px;\n"], ["\n  margin-bottom: 5px;\n"])));
export var PredefinedDatesList = styled('ul').withConfig({ displayName: "PredefinedDatesList", componentId: "sc-17k94ai" })(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  list-style: none;\n  margin: 0;\n  padding: 0;\n"], ["\n  list-style: none;\n  margin: 0;\n  padding: 0;\n"])));
export var PredefinedDatesButton = styled('button').withConfig({ displayName: "PredefinedDatesButton", componentId: "sc-1tdxmv2" })(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  width: 100px;\n  border: none;\n  line-height: 33px;\n  background: transparent;\n  text-align: left;\n  padding: 0;\n\n  ", "\n"], ["\n  width: 100px;\n  border: none;\n  line-height: 33px;\n  background: transparent;\n  text-align: left;\n  padding: 0;\n\n  ",
    "\n"])), function (_a) {
    var isSelected = _a.isSelected;
    return isSelected && {
        fontWeight: 'bold',
    };
});
var PredefinedDatesWrapper = styled('section').withConfig({ displayName: "PredefinedDatesWrapper", componentId: "sc-ip6ukb" })(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  margin-top: 50px;\n  font-size: 0.8rem;\n  line-height: 1.7rem;\n  font-weight: normal;\n  color: #c1c1c1;\n"], ["\n  margin-top: 50px;\n  font-size: 0.8rem;\n  line-height: 1.7rem;\n  font-weight: normal;\n  color: #c1c1c1;\n"])));
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
