import React, { useCallback, useEffect, useState } from 'react';
import ReactDOM from 'react-dom';
import { DEFAULT_POPOVER_WIDTH } from '../../../constants';
import { getAutoPlacing, getRect, isIE, getBreachedFlag, } from './helpers';
import { Arrow, Body, Container, Content } from './styles';
export var Popover = function (_a) {
    var placing = _a.placing, isOpen = _a.isOpen, children = _a.children, anchorElement = _a.anchorElement, width = _a.width, _b = _a.offset, offset = _b === void 0 ? 12 : _b, className = _a.className, disableAutoPlacing = _a.disableAutoPlacing, popoverRoot = _a.popoverRoot;
    var _c = useState(0), containerWidth = _c[0], setContainerWidth = _c[1];
    var _d = useState(null), containerRect = _d[0], setContainerRect = _d[1];
    var _e = useState(false), breached = _e[0], setBreached = _e[1];
    var ie = isIE();
    var rect = getRect(ie ? null : anchorElement);
    var autoPlacing = isOpen && disableAutoPlacing
        ? placing
        : getAutoPlacing(rect, placing, width || containerWidth);
    var containerRef = useCallback(function (node) {
        setContainerWidth((node === null || node === void 0 ? void 0 : node.clientWidth) || DEFAULT_POPOVER_WIDTH);
        setContainerRect(getRect(node));
    }, []);
    useEffect(function () {
        var breachedNextValue = getBreachedFlag(autoPlacing, rect, containerWidth, offset);
        setBreached(breachedNextValue);
        if (breachedNextValue) {
            setContainerWidth(rect.left - offset);
        }
    }, [containerRect]);
    if (isOpen) {
        return ReactDOM.createPortal(React.createElement(Container, { offset: offset, width: width, placing: autoPlacing, rect: rect, className: className, ref: containerRef, breached: breached, containerRect: containerRect },
            React.createElement(Body, { placing: autoPlacing },
                React.createElement(Arrow, { placing: autoPlacing, breached: breached, rect: rect, containerRect: containerRect }),
                React.createElement(Content, null, children))), popoverRoot || document.body);
    }
    if (ie) {
        return (React.createElement(Container, { offset: -1, width: 0, placing: autoPlacing, rect: rect, className: className, breached: breached, containerRect: containerRect }));
    }
    return null;
};
